/*
 * Copyright (C) 1995 Phil Servita (meister@ftp.com)
 */	  
/*
 * portions derived from the Bellcore S/Key (tm) distribution.
 */

#include <stdio.h>
#ifdef USE_STDLIB_H
# include <stdlib.h>
#endif

#include <sys/types.h>

#ifdef USE_STRING_H
# include <string.h>
#endif

#ifdef USE_STRINGS_H
# include <strings.h>
#endif

#ifdef	__MSDOS__
#include <dos.h>
#else	/* Assume BSD unix */
#include <fcntl.h>
#endif
#include "md4.h"
#include "otp.h"

#if (defined(__MSDOS__) || defined(MPU8086) || defined(MPU8080) \
 || defined(vax) || defined (MIPSEL))
#define	LITTLE_ENDIAN	/* Low order bytes are first in memory */
#endif			/* Almost all other machines are big-endian */

/* Crunch a key:
 * concatenate the seed and the password, run through apropriate hash 
 * algorithm and collapse to 64 bits. This is defined as the user's 
 * starting key.
 */

int OTP_KeyCrunch (result, seed, passwd, keycrunch_fcn)
        char *result;	/* 8-byte result */
        char *seed;	/* Seed, any length */
        char *passwd;	/* Password, any length */
        OTPkeycrunchfcn keycrunch_fcn;
{
	return (*keycrunch_fcn) (result, seed, passwd);
}

/* The one-way function f(). Takes 8 bytes and returns 8 bytes in place */

void OTP_IterateHash (x, iterate_fcn)
        char *x;
        OTPiteratefcn iterate_fcn;
{
        (*iterate_fcn) (x);
}

/* Strip trailing cr/lf from a line of text */
void _otp_rip (buf)
     char *buf;
{
     char *cp;

     if ((cp = strchr(buf,'\r')) != NULL)
  	 *cp = '\0';

     if ((cp = strchr(buf,'\n')) != NULL)
	 *cp = '\0';
}

/************************/
#ifdef	__MSDOS__
char *_otp_readpass (buf, n)
        char *buf;
        int n;
{
	int i;
	char *cp;

	for(cp=buf,i = 0; i < n ; i++)
		if ((*cp++ = bdos(7,0,0)) == '\r')
			break;
	*cp = '\0';
	printf("\n");
	_otp_rip (buf);
	return buf;
}
#else
char *_otp_readpass (buf, n)
        char *buf;
        int n;
{

        OTP_tty_cbreak_noecho (fileno (stdin));
	fgets (buf, n, stdin);
	_otp_rip (buf);

	/* Restore previous tty modes */
        OTP_ttynorm (fileno (stdin));

	/*
	after the secret key is taken from the keyboard, the line feed is
	written to standard error instead of standard output.  That means that
	anyone using the program from a terminal won't notice, but capturing
	standard output will get the key words without a newline in front of
	them. 
	*/
        fprintf (stderr, "\n");
        fflush (stderr);
	_otp_sevenbit (buf);

	return buf;
}

#endif

/* remove backspaced over charaters from the string */
void _otp_backspace (buf)
        char *buf;
{
	char bs = 0x8;
	char *cp = buf;
	char *out = buf;

	while(*cp){
		if( *cp == bs ) {
			if(out == buf){
				cp++;
				continue;
			}
			else {
			  cp++;
			  out--;
			}
		}
		else {
			*out++ = *cp++;
		}

	}
	*out = '\0';
	
}

void _otp_sevenbit (s)
        char *s;
{
	/* make sure there are only 7 bit code in the line*/
	while(*s){
		*s = 0x7f & ( *s);
		s++;
	}
}
